<template>
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">Roster</div>

                <div class="card-body">
                    <table id="idItemTable" class="table table-striped table-bordered nowrap mt-2" style="width:100%"></table>
                </div>
            </div>
            
            <componentModalShowStats v-if="isShowComponentModalShowStats" :dataComponentModalShowStats="dataComponentModalShowStats"></componentModalShowStats>
            <componentModalShowDetails v-if="isShowComponentModalShowData" :dataComponentModalShowData="dataComponentModalShowData"></componentModalShowDetails>
        </div>
</template>

<script>
import componentModalShowDetails from '../components/partials/componentModalShowDetails.vue';
import componentModalShowStats from '../components/partials/componentModalShowStats.vue';
    export default {
        components: {
            componentModalShowDetails,
            componentModalShowStats
        },
        data(){
            return {
                requestLimit: {
                    'dtItemTable.search': 0
                },
                dt: {
                    'dtItemTable.search': null
                },
                isShowComponentModalShowData: false,
                dataComponentModalShowData: [],
                isShowComponentModalShowStats: false,
                dataComponentModalShowStats: [],
            }
        },
        mounted() {
            let _s = this
            setTimeout(function(){
                _s.generateDT();

            }, 300)

            setTimeout(function(){
                _s.initButtons();

            }, 600)
        },
        methods: {
            initButtons(){
                let _s = this

                $('#app').on('click', 'button.showDetails', function() {
                    let _ss = this;
                    let id = $(_ss).data('id');
                    _s.isShowComponentModalShowData = true;
                    _s.dataComponentModalShowData = dtFn.getSelectedRowByIdColumn(_s.dt['dtItemTable.search'].data(), id);
                });

                $('#app').on('click', 'button.showStats', function() {
                    let _ss = this;
                    let id = $(_ss).data('id');

                    _s.isShowComponentModalShowStats = true;
                    _s.dataComponentModalShowStats = dtFn.getSelectedRowByIdColumn(_s.dt['dtItemTable.search'].data(), id);
                });
            },
            generateDT() {
                let _s = this;
                if (_.get(_s.dt, 'dtItemTable.search', null)!=null) return true;

                _s.dt['dtItemTable.search'] = $('#idItemTable').DataTable( {
                    order: [[ 0, "desc" ]],
                    processing: true,
                    serverSide: true,
              
                    ajax: {
                        url: apiBaseURL('roster/search'),
                        type: "POST",
                        error: function (xhr, error, thrown) {
                            if (_.get(_s.requestLimit, 'dtItemTable.search', 0) < getRequestLimit()) {
                                _s.dt['dtItemTable.search'].ajax.reload(null, false);
                                _s.requestLimit['dtItemTable.search'] = _s.requestLimit['dtItemTable.search'] + 1;
                            }
                            else {
                                _s.dt['dtItemTable.search'].processing( false );
                            }
                        }
                    },
                    columnDefs: [
                        { className: 'text-left', targets: [0,1,2,3,4]  },
                    ],
                    columns: [
                        { data: "id", title: "Action", render : function ( value, type, row, meta ) {
                            return [
                                '<button data-id="'+value+'" class="showStats btn btn-success btn-sm">View Stat</button>',
                                '<button data-id="'+value+'" class="showDetails btn btn-warning btn-sm">View Details</button>'
                            ].join('&nbsp');
                        }},
                        { data: "team_code", title: "Team Code" },
                        { data: "number", title: "Number" },
                        { data: "name", title: "Name" },
                        { data: "pos", title: "POS" },
                        { data: "height", title: "Height" },
                        { data: "weight", title: "Weight" },
                        { data: "dob", title: "Date of Birth" },
                        { data: "nationality", title: "Nationality" },
                        { data: "years_exp", title: "Years Exp" },
                        { data: "college", title: "College" },
                    ]
                } );
                new $.fn.dataTable.FixedHeader( _s.dt['dtItemTable.search'] );
            },
        }
    }
</script>
